var g_vdcs = {};
var g_timeout_id;
var g_auth = {
  "dSUID": undefined,
  "code": undefined,
  "refresh_token": undefined,
  "access_token": undefined
};
var g_client_id = "52823f931877590c917b23f7";
var g_client_secret = "Q5rt19RMedbTkHblsIE5mKK3rhKKQQcCJ9AJwr";

var vdc_strings =
{
    BUTTON_CONNECT:         "register",
    BUTTON_DISCONNECT:      "dissociate",
    STATUS_CONNECTED:       "connected",
    STATUS_DISCONNECTED:    "not connected"
};

var vdc_config =
{
    model_uid:              "NetAtmo Weather Station",
    search_intervall_ms:    20000
};

var vdc_render_no_devices = function()
{
    $("#device_list").hide();
    $("#empty").text("No Netatmo vDCs found, check your addon and package setup.");
};


var getURLParameter = function getURLParameter(p)
{
    var url = decodeURIComponent(window.location.search.substring(1));
    var variables = url.split('&');
    var name;
    var i;

    for (i = 0; i < variables.length; i++)
    {
        name = variables[i].split('=');

        if (name[0] === p) {
            return name[1] === undefined ? true : name[1];
        }
    }
};

String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

var vdc_clear_search_timeout = function()
{
    if (g_timeout_id !== undefined)
    {
        window.clearTimeout(g_timeout_id);
    }
};

var vdc_start_search_timeout = function()
{
    g_timeout_id = window.setTimeout(vdc_search,
                                     vdc_config.search_intervall_ms);
};

var vdc_is_authenticated = function(device)
{
    if ((device) && (device.connected) && (device.username) && (device.username.length > 0))
    {
        return true;
    }
    return false;
};

var vdc_show_message = function(title, message, reload)
{
    $("#modal_dialog_title").html(title);

    if (reload === true)
    {
        message = message +
            "<div class=\"right\"><p><button type=\"button\" id=\"reload\">Reload</button></p></div>";
    }
    $("#modal_dialog_message").html(message);

    if (reload === true)
    {
        $("#reload").click(
            function(event)
            {
                event.preventDefault();
                window.location.hash = "";
                window.location.reload();
                return;
            });
    }


    window.location.hash = "#open_modal_dialog";
};

var vdc_get_client_id_callback = function(device, data)
{
    var i;
    var props = data.result.ResponseGetProperty;
    var client_id = "";

    for (i = 0; i < props.length; i++)
    {
        var property = props[i];
        if (property.name === "x-netatmo-client-id")
        {
            client_id = property.value;
        }
    }

    if (client_id.length === 0)
    {
        vdc_show_message("Error", "Could not get client id for authentication", true);
        return;
    }

    var redirect_uri = encodeURIComponent(window.location.origin + window.location.pathname);
    var url = "https://api.netatmo.net/oauth2/authorize?response_type=code&client_id=" +
              client_id + "&redirect_uri=" + redirect_uri + "&state=" + device.dSUID + "&scope=read_station";

    top.location.href=url;
}

var vdc_show_password_prompt = function(title, message, callback)
{
    $("#modal_dialog_title").html(title);

    var html = "<p><table><tr><td>User name:&nbsp;</td>" +
               "<td><input type=\"text\" id=\"username\"/></td>" +
               "<tr><td>Password:&nbsp;</td>" +
               "<td><input type=\"password\" id=\"password\"/></td></tr>" +
               "</table></p>";

    var button = "<div class=\"right\"><p>" +
                 "<button type=\"button\" id=\"savepw\">Submit</button></p>" +
                 "</div>";


    $("#modal_dialog_message").html(message + html + button);

    if (callback)
    {
        var cb = function(evt)
        {
            evt.preventDefault();
            var username = $('#username').val();
            var password = $('#password').val();
            if ((username.length === 0) || (password.length === 0))
            {
                return;
            }

            window.location.hash = "#close";
            callback(username, password);
        };

        $("#savepw").click(cb);
    }

    window.location.hash = "#open_modal_dialog";
};


var vdc_request_failed = function(data)
{
    var err = data.statusText;
    if (data.responseJSON && (data.responseJSON.ok === false))
    {
        err = data.responseJSON.message;
    }
    vdc_show_message("Error",
        "Request failed: " + err, true);
};

var vdc_render_remove_device = function(dsuid)
{
   $("#" + dsuid).remove();
};

var vdc_auth_button_clicked = function(dsuid, evt)
{
    var device = g_vdcs[dsuid];
    if (device === undefined)
    {
        vdc_show_message("Error", "Could not find device " +
                         device.DisplayID + "!<br/>" +
                         "Something went wrong, please reload the page", true);
    }

    if (vdc_is_authenticated()) {
        $.getJSON("/json/property/vdcquery?", {
            query: "setProperty(deviceId=" + dsuid + ")/" +
                "(x-netatmo-username=\"\")" +
                "(x-netatmo-refresh_token=\"\")"
            },
            function() {}).fail(vdc_request_failed);
        return;
    }

    var callback = function(data)
    {
        vdc_get_client_id_callback(device, data);
    };

    $.getJSON("/json/property/vdcquery?query=getProperty(deviceId=" +
              device.dSUID +
              ")/x-netatmo-client-id",
              callback).fail(vdc_request_failed);
};

var vdc_auth2_button_clicked = function(dsuid, evt)
{
    var redirect_uri = encodeURIComponent(window.location.origin + window.location.pathname);
    var url = "https://api.netatmo.net/oauth2/authorize?response_type=code&client_id=" +
              g_client_id + "&redirect_uri=" + redirect_uri + "&state=" + dsuid + "&scope=read_station";
    top.location.href=url;
}

var vdc_render_add_device = function(dsuid, connected)
{
   var device = g_vdcs[dsuid];
   if (device === undefined)
   {
       return;
   }

   vdc_render_remove_device(dsuid);

   var state = vdc_strings.STATUS_DISCONNECTED;
   var button = vdc_strings.BUTTON_CONNECT;
   if (connected)
   {
        state = vdc_strings.STATUS_CONNECTED;
        button = vdc_strings.BUTTON_DISCONNECT;
   }

   var row = "<tr id=\"" + dsuid + "\"><td>" +
             "<img src=\"icon16.png" + "\"/></td><td>" +
             device.name + "</td><td>" +
             device.DisplayID + "</td><td id=\"state_" + dsuid + "\">" +
             device.username + "</td><td>" +
             state + "</td><td>" +
             "<button id=\"btn_" + dsuid + "\" type=\"button\">" +
             button +
             "</button></td></tr>";

   $("#device_list_content").append(row);

   var callback = function(evt)
   {
       vdc_auth_button_clicked(dsuid, evt);
   };

   $("#btn_" + dsuid).click(callback);
};

var vdc_render_update_device_status = function(dsuid)
{
    var device = g_vdcs[dsuid];
    if (vdc_is_authenticated(device))
    {
        $("state_" + dsuid).text(vdc_strings.STATUS_CONNECTED +
                                 device.username);
    }
    else
    {
        $("state_" + dsuid).text(vdc_strings.STATUS_DISCONNECTED);
    }
};

var vdc_setup = function()
{
    g_auth["code"] = getURLParameter("code");
    g_auth["dSUID"] = getURLParameter("state");
    g_auth["access_token"] = getURLParameter("access_token");

    // clean potential reload leftovers from the modal window
    window.location.hash = "";

    $("#device_list").hide();
    $("a.close").mouseup(
        function()
        {
            // clear #close from the URL
            var t = setTimeout(function()
                {
                    window.location.hash = "";
                    window.clearTimeout(t);
                }, 10);
        });
};


var vdc_device_query_callback = function(device, data)
{
    var i;
    var props = data.result.ResponseGetProperty;

    var modeluid = "";
    var connected = false;
    var username = "";

    for (i = 0; i < props.length; i++)
    {
        var property = props[i];
        if (property.name === "modelUID")
        {
            modeluid = property.value;
        }
        else if (property.name === "x-netatmo-connection-status")
        {
            connected = property.value;
        }
        else if (property.name === "x-netatmo-username")
        {
            username = property.value;
        }
    }

    if (modeluid !== vdc_config.model_uid)
    {
        return;
    }

    if (Object.keys(g_vdcs).length === 0)
    {
        $("#empty").empty();
        $("#device_list").show();
    }

    g_vdcs[device.dSUID] = device;
    g_vdcs[device.dSUID].connected = connected;
    g_vdcs[device.dSUID].username = username;

    vdc_render_add_device(device.dSUID, connected);
};

var vdc_search = function()
{
    vdc_clear_search_timeout();
    // load apartment structure and search for netatmo vdc's
    $.getJSON("/json/apartment/getCircuits",
              vdc_search_callback).fail(vdc_request_failed).fail(vdc_request_failed);
};

var vdc_check_auth = function(device)
{
    if ((g_auth.dSUID !== undefined) && (g_auth.code !== undefined))
    {
        jQuery.each(g_vdcs, function(key, val)
        {
            if (key === g_auth.dSUID)
            {
                var redirect_uri = encodeURIComponent(window.location.origin +
                    window.location.pathname);
                var query = {
                    "client_id" :  g_client_id,
                    "client_secret" : g_client_secret,
                    "grant_type" : "authorization_code",
                    "code" : g_auth.code,
                    "redirect_uri" : window.location.origin + window.location.pathname,
                    "scope" : "read_station"
                };
                var url = "https://api.netatmo.net/oauth2/token";
                var jqxhr = $.post(url, query, function(data) {
                    g_auth.access_token = data.access_token;
                    g_auth.refresh_token = data.refresh_token;
                    g_auth.refresh_timeout = data.expires_in;
                    g_auth.code = undefined;
                    vdc_check_auth(device);
                });

                return false;
            }
        });
    }

    if ((device.dSUID !== undefined) && (g_auth.refresh_token !== undefined))
    {
        jQuery.each(g_vdcs, function(key, val)
        {
            if (key === g_auth.dSUID)
            {
                var callback = function() {
                    g_auth.refresh_token = undefined;
                };

                $.getJSON("/json/property/vdcquery?", {
                    query: "setProperty(deviceId=" + g_auth.dSUID + ")/" +
                        "(x-netatmo-refresh_token=\"" + g_auth.refresh_token + "\")" +
                        ",(x-netatmo-refresh_timeout=\"" + g_auth.refresh_timeout + "\")" +
                        ",(x-netatmo-client_secret=\"" + g_client_secret + "\")" +
                        ",(x-netatmo-access_token=\"" + g_auth.access_token + "\")"
                    },
                    callback).fail(vdc_request_failed);

                $.getJSON("https://api.netatmo.net/api/getuser?access_token=" + g_auth.access_token,
                    function(data) {
                        device.username = data.body.mail;
                        $.getJSON("/json/property/vdcquery?", {
                            query: "setProperty(deviceId=" + g_auth.dSUID + ")/" +
                                "(x-netatmo-username=\"" + device.username + "\")"
                            },
                            callback).fail(vdc_request_failed);
                    },
                    callback).fail(vdc_request_failed);

                return false;
            }
        });
    }

    vdc_start_search_timeout();
};

var vdc_query_device = function(device, remaining)
{
    var callback = function(data)
    {
        if (data.ok === true)
        {
            vdc_device_query_callback(device, data);
        }

        if (remaining.length > 0)
        {
            var next = remaining.shift();
            vdc_query_device(next, remaining);
        }
        else
        {
            if (Object.keys(g_vdcs).length === 0)
            {
                vdc_render_no_devices();
                vdc_start_search_timeout();
            }
            else
            {
                vdc_check_auth(device);
            }
        }
    };

    $.getJSON("/json/property/vdcquery?query=getProperty(deviceId=" +
              device.dSUID +
              ")/modelUID,x-netatmo-connection-status,x-netatmo-username",
              callback).fail(callback);
};

var vdc_search_callback = function(data)
{
    var devices = [];
    var i;

    vdc_clear_search_timeout();

    try
    {
        var circuits = data.result.circuits
        for (i = 0; i < circuits.length; i++)
        {
            var circuit = circuits[i];
            if ((circuit.isPresent === true) &&
                (circuit.isValid === true) &&
                (circuit.busMemberType === 33) &&   // vdc host
                (circuit.VdcModelUID === vdc_config.model_uid))   // netatmo vdc
            {
                devices.push(circuits[i]);
            }
        }
    } catch (err) {}

    if (devices.length === 0)
    {
        g_vdcs = {};
        vdc_render_no_devices();
        vdc_start_search_timeout();
        return;
    }

    jQuery.each(g_vdcs, function(key, val)
        {
            for (i = 0; i < devices.length; i++)
            {
                if (key === devices[i].dSUID)
                {
                    return;
                }
            }

            vdc_render_remove_device(key);
            delete g_vdcs[key];
        });


    var next = devices.shift();
    vdc_query_device(next, devices);
};

$(document).ready(function()
{
    $.ajaxPrefilter(function(options)
    {
        if ((!options.url.match(/\/api.netatmo.net\//)) && (!options.beforeSend))
        {
            options.beforeSend = function(xhr)
            {
                var csrf = $.cookie("csrf-token");
                if (csrf)
                { 
                    xhr.setRequestHeader('X-CSRF-Token', csrf);
                }
            }
        }
    });
    vdc_setup();
    vdc_search();
});
